diff --git a/javafx-ui-controls/src/javafx/scene/control/Button.java b/javafx-ui-controls/src/javafx/scene/control/Button.java
--- a/javafx-ui-controls/src/javafx/scene/control/Button.java
+++ b/javafx-ui-controls/src/javafx/scene/control/Button.java
@@ -24,15 +24,13 @@
  */
 package javafx.scene.control;
 
-import java.util.Set;
 import javafx.beans.property.BooleanProperty;
 import javafx.beans.property.BooleanPropertyBase;
+import javafx.css.PseudoClass;
 import javafx.event.ActionEvent;
 import javafx.scene.Node;
-
+import com.sun.javafx.accessible.providers.AccessibleProvider;
 import com.sun.javafx.scene.control.accessible.AccessibleButton;
-import com.sun.javafx.accessible.providers.AccessibleProvider;
-import javafx.css.PseudoClass;
 import com.sun.javafx.scene.control.skin.ButtonSkin;
 
 /**
@@ -83,6 +81,17 @@
     }
 
     /**
+     * Creates a Button with a graphic. This is the same as
+     * creating a Button using the default constructor and calling
+     * {@link #setGraphic(javafx.scene.Node)}.
+     *
+     * @param graphic The graphic for the label
+     */
+    public Button(Node graphic) {
+        super(graphic);
+    }
+
+    /**
      * Creates a button with the specified text and icon for its label.
      *
      * @param text A text string for its label.
diff --git a/javafx-ui-controls/src/javafx/scene/control/ButtonBase.java b/javafx-ui-controls/src/javafx/scene/control/ButtonBase.java
--- a/javafx-ui-controls/src/javafx/scene/control/ButtonBase.java
+++ b/javafx-ui-controls/src/javafx/scene/control/ButtonBase.java
@@ -24,15 +24,14 @@
  */
 package javafx.scene.control;
 
-import java.util.Set;
-import javafx.css.PseudoClass;
 import javafx.beans.property.ObjectProperty;
 import javafx.beans.property.ObjectPropertyBase;
+import javafx.beans.property.ReadOnlyBooleanProperty;
+import javafx.beans.property.ReadOnlyBooleanWrapper;
+import javafx.css.PseudoClass;
 import javafx.event.ActionEvent;
 import javafx.event.EventHandler;
 import javafx.scene.Node;
-import javafx.beans.property.ReadOnlyBooleanProperty;
-import javafx.beans.property.ReadOnlyBooleanWrapper;
 
 /**
  * Base class for button-like UI Controls, including Hyperlinks, Buttons,
@@ -67,6 +66,17 @@
     }
 
     /**
+     * Creates a ButtonBase with a graphic. This is the same as
+     * creating a ButtonBase using the default constructor and calling
+     * {@link #setGraphic(javafx.scene.Node)}.
+     *
+     * @param graphic The graphic for the label
+     */
+    public ButtonBase(Node graphic) {
+        super(graphic);
+    }
+
+    /**
      * Create a ButtonBase with the given text and graphic.
      * @param text null text is treated as the empty string
      * @param graphic a null graphic is acceptable
diff --git a/javafx-ui-controls/src/javafx/scene/control/Labeled.java b/javafx-ui-controls/src/javafx/scene/control/Labeled.java
--- a/javafx-ui-controls/src/javafx/scene/control/Labeled.java
+++ b/javafx-ui-controls/src/javafx/scene/control/Labeled.java
@@ -26,26 +26,27 @@
 package javafx.scene.control;
 
 
-import com.sun.javafx.css.converters.BooleanConverter;
-import com.sun.javafx.css.converters.EnumConverter;
-import com.sun.javafx.css.converters.InsetsConverter;
-import com.sun.javafx.css.converters.PaintConverter;
-import com.sun.javafx.css.converters.SizeConverter;
-import com.sun.javafx.css.converters.StringConverter;
 import java.net.MalformedURLException;
 import java.net.URL;
 import java.util.ArrayList;
 import java.util.Collections;
 import java.util.List;
-
+import javafx.beans.DefaultProperty;
 import javafx.beans.property.BooleanProperty;
 import javafx.beans.property.DoubleProperty;
 import javafx.beans.property.ObjectProperty;
-import javafx.beans.property.ObjectPropertyBase;
 import javafx.beans.property.ReadOnlyObjectProperty;
 import javafx.beans.property.SimpleBooleanProperty;
 import javafx.beans.property.SimpleStringProperty;
 import javafx.beans.property.StringProperty;
+import javafx.css.CssMetaData;
+import javafx.css.FontCssMetaData;
+import javafx.css.StyleOrigin;
+import javafx.css.StyleableBooleanProperty;
+import javafx.css.StyleableDoubleProperty;
+import javafx.css.StyleableObjectProperty;
+import javafx.css.StyleableProperty;
+import javafx.css.StyleableStringProperty;
 import javafx.geometry.Insets;
 import javafx.geometry.Orientation;
 import javafx.geometry.Pos;
@@ -56,17 +57,12 @@
 import javafx.scene.paint.Paint;
 import javafx.scene.text.Font;
 import javafx.scene.text.TextAlignment;
-
-import javafx.beans.DefaultProperty;
-import javafx.css.CssMetaData;
-import javafx.css.FontCssMetaData;
-import javafx.css.StyleOrigin;
-import javafx.css.StyleableBooleanProperty;
-import javafx.css.StyleableDoubleProperty;
-import javafx.css.StyleableObjectProperty;
-import javafx.css.StyleableProperty;
-
-import javafx.css.StyleableStringProperty;
+import com.sun.javafx.css.converters.BooleanConverter;
+import com.sun.javafx.css.converters.EnumConverter;
+import com.sun.javafx.css.converters.InsetsConverter;
+import com.sun.javafx.css.converters.PaintConverter;
+import com.sun.javafx.css.converters.SizeConverter;
+import com.sun.javafx.css.converters.StringConverter;
 
 
 /**
@@ -118,6 +114,15 @@
     }
 
     /**
+     * Creates a Labeled with a graphic. This is the same as
+     * creating a basic Label and calling {@link #setGraphic(javafx.scene.Node)}.
+     * @param graphic The graphic for the label
+     */
+    public Labeled(Node graphic) {
+        setGraphic(graphic);
+    }
+
+    /**
      * Creates a Label with text and a graphic
      * @param text The text for the label.
      * @param graphic The graphic for the label.