# This patch file was generated by NetBeans IDE
# Following Index: paths are relative to: D:\JavaFX\repos\controls-scrum\rt
# This patch can be applied using context Tools: Patch action on respective folder.
# It uses platform neutral UTF-8 encoding and \n newlines.
# Above lines and this line are ignored by the patching process.
Index: javafx-ui-controls/src/com/sun/javafx/scene/control/skin/ColorPalette.java
--- javafx-ui-controls/src/com/sun/javafx/scene/control/skin/ColorPalette.java Base (BASE)
+++ javafx-ui-controls/src/com/sun/javafx/scene/control/skin/ColorPalette.java Locally Modified (Based On LOCAL)
@@ -35,7 +35,6 @@
 import javafx.collections.FXCollections;
 import javafx.collections.ListChangeListener;
 import javafx.event.ActionEvent;
-import javafx.event.Event;
 import javafx.event.EventHandler;
 import javafx.geometry.NodeOrientation;
 import javafx.geometry.Pos;
@@ -50,6 +49,7 @@
 import javafx.scene.paint.Color;
 import javafx.scene.shape.Rectangle;
 import javafx.scene.shape.StrokeType;
+import javafx.stage.Stage;
 
 
 public class ColorPalette extends VBox {
@@ -89,43 +89,41 @@
         customColorLink.setVisited(true); // so that it always appears blue 
         customColorLink.setOnAction(new EventHandler<ActionEvent>() {
             @Override public void handle(ActionEvent t) {
-                if (customColorDialog == null) {
-                    customColorDialog = new CustomColorDialog(popupControl);
-                    customColorDialog.customColorProperty().addListener(new ChangeListener<Color>() {
-                        @Override public void changed(ObservableValue<? extends Color> ov, 
-                                                                Color t, Color t1) {
-                            colorPicker.setValue(customColorDialog.customColorProperty().get());
-                        }
-                    });
-                    customColorDialog.setOnSave(new Runnable() {
+                popupControl.setAutoHide(false);
 
-                        @Override
-                        public void run() {
-                            Color customColor = customColorDialog.customColorProperty().get();
-                            ColorSquare cs = new ColorSquare(customColor, true);
-                            customSquares.add(cs);
-                            buildCustomColors();
-                            colorPicker.getCustomColors().add(customColor);
-                            updateSelection(customColor);
-                            Event.fireEvent(colorPicker, new ActionEvent());
-                            colorPicker.hide();
-                        }
-                    });
-                    customColorDialog.setOnUse(new Runnable() {
+                Stage right = new Stage();
+                right.setTitle("Right");
+                right.setX(popupControl.getX() + popupControl.getWidth());
+                right.setY(popupControl.getY());
+                right.setWidth(200);
+                right.setHeight(200);
+                right.show();
 
-                        @Override
-                        public void run() {
-                            Event.fireEvent(colorPicker, new ActionEvent());
-                            colorPicker.hide();
+                Stage bottom = new Stage();
+                bottom.setTitle("Bottom");
+                bottom.setX(popupControl.getX());
+                bottom.setY(popupControl.getY() + popupControl.getHeight());
+                bottom.setWidth(200);
+                bottom.setHeight(200);
+                bottom.show();
+                
+                Stage top = new Stage();
+                top.setTitle("Top");
+                top.setX(popupControl.getX());
+                top.setY(popupControl.getY() - 200);
+                top.setWidth(200);
+                top.setHeight(200);
+                top.show();
+
+                Stage left = new Stage();
+                left.setTitle("Left");
+                left.setX(popupControl.getX() - 200);
+                left.setY(popupControl.getY());
+                left.setWidth(200);
+                left.setHeight(200);
+                left.show();
                         }
                     });
-                }
-                customColorDialog.setCurrentColor(colorPicker.valueProperty().get());
-                if (popupControl != null) popupControl.setAutoHide(false);
-                customColorDialog.show();
-                if (popupControl != null) popupControl.setAutoHide(true);
-            }
-        });
         
         initNavigation();
         customColorGrid.getStyleClass().add("color-picker-grid");