diff -r bb776c1272fa modules/graphics/src/main/java/com/sun/glass/ui/lens/LensTouchInputSupport.java
--- a/modules/graphics/src/main/java/com/sun/glass/ui/lens/LensTouchInputSupport.java	Thu Nov 28 11:52:34 2013 +0200
+++ b/modules/graphics/src/main/java/com/sun/glass/ui/lens/LensTouchInputSupport.java	Sun Dec 01 12:04:06 2013 +0200
@@ -77,14 +77,6 @@
                                         */
     private static final boolean enableDeviceTrace;
 
-    /**
-     * This property is used in conjunction of enableDeviceTrace. When set to
-     * true trace logging will include a timestamp.
-     * Property is disabled by default.
-     * 
-     */
-    private static final boolean useTimeStampInTrace;
-
     static {
         touchTapRadius = AccessController.doPrivileged(
         new PrivilegedAction<Integer>() {
@@ -114,17 +106,10 @@
         new PrivilegedAction<Boolean>() {
             @Override
             public Boolean run() {
-                return Boolean.getBoolean("lens.input.trace.Enabled");
+                return Boolean.getBoolean("lens.input.trace");
             }
         });
 
-        useTimeStampInTrace = AccessController.doPrivileged(
-        new PrivilegedAction<Boolean>() {
-            @Override
-            public Boolean run() {
-                return Boolean.getBoolean("lens.input.trace.UseTimeStamp");
-            }
-        });
     }
 
 
diff -r bb776c1272fa modules/graphics/src/main/native-glass/lens/input/udev/udevInput.c
--- a/modules/graphics/src/main/native-glass/lens/input/udev/udevInput.c	Thu Nov 28 11:52:34 2013 +0200
+++ b/modules/graphics/src/main/native-glass/lens/input/udev/udevInput.c	Sun Dec 01 12:04:06 2013 +0200
@@ -91,22 +91,22 @@
 #define LENS_TEST_INPUT "LENS_TEST_INPUT"
 
 //used for tracing low level events, udev and udev monitor events
-static unsigned long traceStartTime;
+static struct timeval tv_start;
 static jboolean isTraceTimeInit = JNI_FALSE;
-#define TRACE(format, ...)                                              \
-    if (gEnableDeviceTrace) {                                           \
-        if (gUseTimeStamp) { \
-            if (!isTraceTimeInit) { \
-                traceStartTime = lens_input_getTimeStamp(); \
-                isTraceTimeInit = JNI_TRUE; \
-            } \
-            unsigned long delta = lens_input_getTimeStamp() - traceStartTime;             \
-            DEBUG_PRINTF("lens.input.trace: %lu.%lu " format, (unsigned long)(delta/1000000), (unsigned long)(delta%1000000)  , ##__VA_ARGS__);   \
-        } else {                                                        \
-            DEBUG_PRINTF("lens.input.trace: "format, ##__VA_ARGS__);   \
-        }                                                               \
-    };
-
+#define TRACE(format, ...) {                                        \
+    if (gEnableDeviceTrace) {                                       \
+        struct timeval tv;                                          \
+        if (!isTraceTimeInit) {                                     \
+            gettimeofday(&tv_start,NULL);                           \
+            isTraceTimeInit = JNI_TRUE;                             \
+        }                                                           \
+        gettimeofday(&tv,NULL);                                     \
+        printf("lens.input.trace: %lu.%lu " format,                 \
+              (tv.tv_sec-tv_start.tv_sec),                          \
+              (tv.tv_usec - tv_start.tv_usec), ##__VA_ARGS__);      \
+        fflush(stdout);                                             \
+    }                                                               \
+}//end TRACE
 
 ////// data structures
 
@@ -258,7 +258,6 @@
 
 //Trace
 static jboolean gEnableDeviceTrace = JNI_FALSE;
-static jboolean gUseTimeStamp = JNI_FALSE;
 
 //JNI
 static JNIEnv *gJNIEnv = NULL;
@@ -309,7 +308,6 @@
 static void lens_input_deviceInfoRelease(LensInputDevice *device);
 static void lens_input_deviceNotify(JNIEnv *env,
                                     LensInputDevice *device, jboolean attach);
-static unsigned long lens_input_getTimeStamp();
 
 // udev functions
 static void lens_input_udevFindDevices(JNIEnv *env);
@@ -375,10 +373,6 @@
                                                            lensTouchInputSupport,
                                                            "enableDeviceTrace",
                                                            "Z");
-        jfieldID timeStampVar = (*env)->GetStaticFieldID(env,
-                                                         lensTouchInputSupport,
-                                                         "useTimeStampInTrace",
-                                                         "Z");
         //try to set tap radius
         if (radiusVar != NULL) {
             int confRadius = (*env)->GetStaticIntField(env,
@@ -448,26 +442,9 @@
             GLASS_LOG_CONFIG("Tracing device raw information is %s",
                              gEnableDeviceTrace? "enabled" : "disabled");
         } else {
-            GLASS_LOG_SEVERE("Could not find static enableDeviceTrace filed in %s "
-                             "disabling device raw trace information",
-                             className);
             gEnableDeviceTrace = JNI_FALSE;
         }
 
-         //try to set time stamp for trace property
-        if (timeStampVar != NULL) {
-            gUseTimeStamp = (*env)->GetStaticBooleanField(env,
-                                                          lensTouchInputSupport,
-                                                          timeStampVar);
-            GLASS_LOG_CONFIG("Time stamp on device trace is %s",
-                             gUseTimeStamp? "enabled" : "disabled");
-        } else {
-            GLASS_LOG_SEVERE("Could not find static useTimeStampInTrace filed in %s "
-                             "disabling time stamp option",
-                             className);
-            gUseTimeStamp = JNI_FALSE;
-        }
-
     } else {
         GLASS_LOG_SEVERE("Could not find %s", className);
     }
@@ -545,7 +522,7 @@
         }
         //Free device object
         udev_device_unref(udev_device);
-        TRACE("[device discovery] Finished processing %s\n\n", syspath);
+        TRACE("[device discovery] Finished processing %s\n", syspath);
     }
 
     /* Free the enumerator object */
@@ -648,12 +625,12 @@
     if (!strcmp(key, "ID_INPUT_KEYBOARD")) {
         device->isKeyboard = JNI_TRUE;
         isValidDevice = JNI_TRUE;
-        TRACE("[properties check] Device marked as keyboard (Device %s contain ID_INPUT_KEYBOARD property)",
+        TRACE("[properties check] Device is marked as keyboard",
               device->info->name);
     } else if (!strcmp(key, "ID_INPUT_MOUSE")) {
         device->isPointer = JNI_TRUE;
         isValidDevice = JNI_TRUE;
-       TRACE("[properties check] Device marked as pointer (Device %s contain ID_INPUT_MOUSE property)",
+       TRACE("[properties check] Device is marked as pointer",
               device->info->name);
     } else if (!strcmp(key, "ID_INPUT_TOUCHSCREEN")) {
         device->isTouch = JNI_TRUE;
@@ -662,7 +639,7 @@
         //lens_input_deviceInitCapabilities()
         device->touchProtocolType = TOUCH_PROTOCOL_ST;
         isValidDevice = JNI_TRUE;
-        TRACE("[properties check] Device is marked as touch (Device %s contain ID_INPUT_TOUCHSCREEN property)",
+        TRACE("[properties check] Device is marked as touch",
               device->info->name);
     }
     return isValidDevice;
@@ -1281,8 +1258,10 @@
 
                 numOfEvents = device->readOffset / (int)sizeof(struct input_event);
 
-                    GLASS_LOG_FINEST("Got event on %s, count=%i",
-                                     device->info->name, numOfEvents);
+                TRACE("[event] read %i events on %s[%s]",
+                      numOfEvents,
+                      device->info->devNode,
+                      device->info->name);
 
 
                 for (eventIndex = 0; eventIndex < numOfEvents; eventIndex ++) {
@@ -2566,17 +2545,6 @@
 
 }
 
-/**
- * Utility function that return current microsecond timestamp
- * 
- * @return unsigned long current timestamp
- */
-static unsigned long lens_input_getTimeStamp() {
-    struct timeval tv;
-    gettimeofday(&tv,NULL);
-    return 1000000 * tv.tv_sec + tv.tv_usec;
-}
-
 ////// Printing functions
 
 /**
@@ -2852,7 +2820,7 @@
             TRACE("FF");
             break;
         default:
-            TRACE("Event type=0x%x code=%0x%x value=%i", event.type, event.code, event.value);
+            TRACE("0x%x 0x%x %i", event.type, event.code, event.value);
             break;
     }
 